Subject: Re: [PATCH net] veth: Avoid drop packets when xdp_redirect performs

From: Toke Høiland-Jørgensen <[email-masked]>
Date: Thu, 20 Oct 2022 18:34:12 +0200

Heng Qi <[email-masked]> writes:

> maybe we should consider a simpler method: when loading xdp in veth,
> we can automatically enable the napi ring of peer veth, which seems to
> have no performance impact and functional impact on the veth pair, and
> no longer requires users to do more things for peer veth (after all,
> they may be unaware of more requirements for peer veth). Do you think
> this is feasible?

It could be, perhaps? One issue is what to do once the XDP program is
then unloaded? We should probably disable NAPI on the peer in this case,
but then we'd need to track whether it was enabled by loading an XDP
program; we don't want to disable GRO/NAPI if the user requested it
explicitly. This kind of state tracking gets icky fast, so I guess it'll
depend on the patch...

-Toke